# Lemmings ![LemmingGif](https://github.com/carlotacb/Lemmings/blob/master/Game/images/readme/lemming.gif)

This is a clone of the well-known videogame [Lemmings](https://en.wikipedia.org/wiki/Lemmings_(video_game)) implemented in C++ via a custom engine. It was developed during the Videogames subject of the Bachelor's Degree in Computer Science of the [Universitat Politècnica de Catalunya](https://www.upc.edu/ca) - [Facultat d'informàtica de Barcelona](https://www.fib.upc.edu/).


![](https://github.com/carlotacb/Lemmings/blob/master/Game/images/readme/lemmings-gameplay.gif)
*Yeah! That is gameplay from this clone!*

## Installing

Just download the build files contained in the .zip from [releases](https://github.com/carlotacb/Lemmings/releases) and execute Lemmings.exe.

## Features & funcionalities
- **9 different levels:** You can select a level from a recap of best scenarios of the original Lemmings, including Fun, Taxing and Tricky.
- **Original music from Lemmings**: All the background music and special effects of the original game are implemented in this clone.
- **Hard mode** <img src="https://github.com/carlotacb/Lemmings/blob/master/Game//images/readme/skull_readme.png" alt="Skull" height="25"/>: In this new difficulty map digged sections will regenerate over time.
- **Software pattern design**: Several software pattern design were used in the implementation in order to have a clear code structure.

## Contributing

Because this is a academic project is not possible to contribute directly to this repo. Said that, feel free to fork it and to expand it in your own way! In order to do that assure that you have the following:

- **A computer.**
- **A C++ compiler**. Even thought is not necessary, [VisualStudio 2017](https://www.visualstudio.com/es/downloads/) is advised in order to streamline the process.

## Built With

* [OpenGL 4.5](https://www.opengl.org/) - Used to renderize graphics.
* [glew 1.13.0](http://glew.sourceforge.net/) - Used to manage OpenGL extensions.
* [freeglut 3.0.0](http://freeglut.sourceforge.net/) - Used to manage windows and OpenGL contexts.
* [FreeType 2.3.5](https://www.freetype.org/) - Used to load images.
* [FMODapi](https://www.fmod.com/) - Used to manage music and sounds.
* [glm 0.9.7.1](https://glm.g-truc.net/) - Used in mathematical operations.


## Authors

| [![Carlota Catot Bragós](https://github.com/carlotacb.png?size=100)](https://github.com/carlotacb) | [![Mario Fernández Villalba](https://github.com/mariofv.png?size=100)](https://github.com/mariofv) |
| ---- | ---- |
| [Carlota Catot Bragós](https://github.com/carlotacb/) | [Mario Fernández Villalba](https://github.com/mariofv/) | 
| _Co-developer_ | _Co-developer_ |


## License

This project is licensed under the MIT License - see the [LICENSE](https://github.com/carlotacb/Lemmings/blob/master/LICENSE) file for details.

## Acknowledgments

Thanks to:
- The lecturers of the Videogames subject of UPC [Jesus Alonso](http://www.cs.upc.edu/~jalonso/) and [Antonio Chica](http://futur.upc.edu/AntonioChicaCalaf), for giving us the opportunity to develop the project.
- [Lemmini](http://lemmini.de/) and [Lemmix](http://ericenzwaan.nl/eric/lemmings/lemmix.htm), for providing some sprites.
- The guys of DMA Design for writing the original Lemmings.
